source set_project_name.tcl

source ../scripts/set_board.tcl


#
# Create GUI Project..
#
file mkdir proj

set scripts_board $BOARDNAME
set current_board_parts [get_board_parts]

if { [string first $scripts_board $current_board_parts] == -1 } {
   puts ""
   puts "ERROR: Please install Trenz Electronic Board Part Files!"
   return 1
}

file delete -force .srcs
file delete -force .Xil

#
# STEP#0: define output directory area.
#

# fixme
create_project -force $PROJNAME ./proj -part $PARTNAME

set outputDir ./out/$PRODID
file mkdir $outputDir


# STEP#1: setup design sources and constraints
#
#read_vhdl -library work [ glob ./src/*.vhd ]         
read_xdc [ glob ../xdc/bitgen_common.xdc ]
read_xdc [ glob ./src/constraints/*.xdc ]


# Set project properties
set obj [current_project]
set_property "default_lib" "xil_defaultlib" $obj
set_property "part" $PARTNAME $obj
set_property "simulator_language" "Mixed" $obj
set_property "target_language" "VHDL" $obj
set_property "board" $BOARDNAME $obj


#set ip repository path
##set_property IP_REPO_PATHS ./ip_rep [current_fileset ]
##update_ip_catalog

# create the BD-Design
create_bd_design "$BDNAME"
source ./src/ipi/$PROJNAME\_bd.tcl
#update_compile_order -fileset sources_1
#update_compile_order -fileset sim_1
#save_bd_design

generate_target all [get_files  ./proj/$PROJNAME.srcs/sources_1/bd/$BDNAME/$BDNAME.bd]

#make_wrapper -files [get_files ./proj/$PROJNAME.srcs/sources_1/bd/$BDNAME/$BDNAME.bd] -top
add_files -norecurse ./proj/$PROJNAME.srcs/sources_1/bd/$BDNAME/hdl/$BDNAME\_wrapper.vhd

#add and associate ELF Files
set fsboot_elf ../../common/sw/minlinux/fs-boot.elf
add_files -norecurse "$fsboot_elf"
set_property SCOPED_TO_REF $BDNAME [get_files -all -of_objects [get_fileset sources_1] "$fsboot_elf"]
set_property SCOPED_TO_CELLS { sys_microblaze } [get_files -all -of_objects [get_fileset sources_1] "$fsboot_elf"]
add_files -fileset sim_1 -norecurse "$fsboot_elf"
set_property SCOPED_TO_REF $BDNAME [get_files -all -of_objects [get_fileset sim_1] "$fsboot_elf"]
set_property SCOPED_TO_CELLS { sys_microblaze } [get_files -all -of_objects [get_fileset sim_1] "$fsboot_elf"]


# STEP#2: run synthesis, report utilization and timing estimates, write checkpoint design
#
#synth_design -top $BDNAME\_wrapper -part $PARTNAME -flatten rebuilt    

