#
# TE utility functions....
#
#
# Write BIF file
#
# Example usage
#
# write_bif name_of_bif_file file name_and_path_to_fsbl
# write_bif C:\xx\xxx.bif "..\option.int" "zynq.fsbl" C:\xx\uboot.elf
#
#

proc write_bif { biffile {fsblfile "zynq_fsbl.elf"} {bitfile ""} {elffile ""} {imagefile ""} {imageoffset ""} {dtbfile ""} {intfile ""} {ssblfile ""} } {


set bif_fp [open "$biffile" w]

puts $bif_fp "the_ROM_image:\n\u007B"
#
# init data
#
if {$intfile!=""} { puts -nonewline $bif_fp {    [init]}}
if {$intfile!=""} { puts $bif_fp $intfile}
if {$intfile == ""} { puts "INT FILE NOT DEFINED..."}
#
# FSBL
#
if {$fsblfile!=""} { puts -nonewline $bif_fp {    [bootloader]}}
if {$fsblfile!=""} { puts $bif_fp $fsblfile}
if {$fsblfile == ""} { puts "FSBL FILE NOT DEFINED..."}
#
# BIT file
#
if {$bitfile!=""} { puts $bif_fp "    $bitfile"}
if {$bitfile == ""} { puts "BIT FILE NOT DEFINED..."}
#
# .ELF file
#
if {$elffile!=""} { puts $bif_fp "    $elffile"}
if {$elffile == ""} { puts "ELF FILE NOT DEFINED..."}
#
# SSBL
#
if {$ssblfile!=""} { puts $bif_fp "    $ssblfile"}
if {$ssblfile == ""} { puts "SSBL FILE NOT DEFINED..."}
#
# DTB file
#
if {$dtbfile!=""} { puts $bif_fp "    $dtbfile"}
if {$dtbfile == ""} { puts "DTB FILE NOT DEFINED..."}
#
# IMAGE file
#
if {$imageoffset!=""} { puts -nonewline $bif_fp {    [offset=}}
if {$imageoffset!=""} { puts -nonewline $bif_fp "$imageoffset"}
if {$imageoffset!=""} { puts -nonewline $bif_fp {]}}
if {$imageoffset == ""} { puts "IMAGE OFFSET NOT DEFINED..."}
if {$imagefile!=""} { puts $bif_fp $imagefile}
if {$imagefile == ""} { puts "IMAGE FILE NOT DEFINED..."}


puts $bif_fp "\u007D"

close $bif_fp



}
