----------------------------------------------------------------------------------
-- Company: 
-- Engineer: Antti Lukats 
-- 
-- Create Date:    10:59:23 12/17/2013 
-- Design Name: 
-- Module Name:    top - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;


-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;

entity top is Port ( 
           GTCLK_P    : in  STD_LOGIC;
           GTCLK_N    : in  STD_LOGIC
--           dummy      : out  STD_LOGIC
	   );
end top;

architecture Behavioral of top is

attribute CLKCM_CFG    : string ;
attribute CLKRCV_TRST  : string ;
attribute CLKSWING_CFG : string ;
attribute BOX_TYPE     : string ;

   component IBUFDS_GTE2
      -- synopsys translate_off
      generic( CLKCM_CFG : boolean :=  TRUE;
               CLKRCV_TRST : boolean :=  TRUE;
               CLKSWING_CFG : boolean :=  TRUE);
      -- synopsys translate_on
      port ( CEB   : in    std_logic; 
             I     : in    std_logic; 
             IB    : in    std_logic; 
             O     : out   std_logic; 
             ODIV2 : out   std_logic);
   end component;
   attribute CLKCM_CFG of IBUFDS_GTE2 : component is "TRUE";
   attribute CLKRCV_TRST of IBUFDS_GTE2 : component is "TRUE";
   attribute BOX_TYPE of IBUFDS_GTE2 : component is "BLACK_BOX";


signal LED_i: std_logic;

signal eos: std_logic;
signal clk: std_logic;
signal cnt: std_logic_vector(31 downto 0);

begin

	GTE_BUF_Inst : IBUFDS_GTE2
	port map (
		CEB	=> '0',
                I  	=>  GTCLK_P,
                IB 	=> GTCLK_N,
                O  	=> clk,
                ODIV2 	=> open
	);

	LED_i <= '1' when eos='0' else not cnt(26);

   STARTUPE2_inst : STARTUPE2
   generic map (
      PROG_USR => "FALSE",  -- Activate program event security feature. Requires encrypted bitstreams.
      SIM_CCLK_FREQ => 0.0  -- Set the Configuration Clock Frequency(ns) for simulation.
   )
   port map (
      CFGCLK 	=> open,     -- 1-bit output: Configuration main clock output
      CFGMCLK 	=> open,     -- 1-bit output: Configuration internal oscillator clock output
      EOS 	=> eos,     -- 1-bit output: Active high output signal indicating the End Of Startup.
      PREQ 	=> open,     -- 1-bit output: PROGRAM request to fabric output
      CLK 	=> '0',      -- 1-bit input: User start-up clock input
      GSR 	=> '0',      -- 1-bit input: Global Set/Reset input (GSR cannot be used for the port name)
      GTS 	=> '0',      -- 1-bit input: Global 3-state input (GTS cannot be used for the port name)
      KEYCLEARB => '0' ,     -- 1-bit input: Clear AES Decrypter Key input from Battery-Backed RAM (BBRAM)
      PACK 	=> '1',      -- 1-bit input: PROGRAM acknowledge input
      USRCCLKO 	=> '1',      -- 1-bit input: User CCLK input
      USRCCLKTS => '1',      -- 1-bit input: User CCLK 3-state enable input
      USRDONEO 	=> LED_i,    -- 1-bit input: User DONE pin output control
      USRDONETS => '0'       -- 1-bit input: User DONE 3-state enable output
   );


	
process(clk)
begin
	if (rising_edge(clk)) then
		cnt <= cnt + X"00000001";
	end if;
end process;

end Behavioral;

